////////////////////////////////////////////////////////////////////////
// recordings.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.recordings")

// <%pre>
#line 1 "recordings.ecpp"


#include <setup.h>
#include <tasks.h>
#include <tools.h>
#include <users.h>
#include <recman.h>
#include <tntconfig.h>
#ifdef HAVE_PCRE2
#include <StringMatch.h>
#endif
#include <vdr/videodir.h>

#define MB_PER_MINUTE 25.75 // this is just an estimate!
#include <string>
std::string argList;
std::string recoring_item;
size_t max_length_recoring_item = 0;

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class recordings_item_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        recordings_item_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class sort_options_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        sort_options_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class del_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        del_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_tools_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_tools_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class archived_disc_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        archived_disc_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_item_dir_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_item_dir_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class delete_error_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        delete_error_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    recordings_item_type recordings_item;
    sort_options_type sort_options;
    del_rec_type del_rec;
    edit_rec_type edit_rec;
    rec_tools_type rec_tools;
    archived_disc_type archived_disc;
    rec_item_dir_type rec_item_dir;
    delete_error_type delete_error;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("recordings");

static const char* rawData = "p\001\000\000q\001\000\000r\001\000\000s\001\000\000\227\001\000\000\242\001\000\000\245"
  "\001\000\000a\002\000\000\267\010\000\000\270\010\000\000\272\010\000\000\273\010\000\000\275\010\000\000\276\010\000"
  "\000\371\010\000\000\014\t\000\000\017\t\000\000\020\t\000\000\246\t\000\000\374\t\000\000\033\n\000\0005\n\000\0006"
  "\n\000\0007\n\000\0009\n\000\000R\n\000\000S\n\000\000b\n\000\000\223\n\000\000\242\n\000\000\244\n\000\000\247\n\000"
  "\000\250\n\000\000\251\n\000\000\253\n\000\000\325\n\000\000\331\n\000\000#\013\000\000'\013\000\000w\013\000\000{"
  "\013\000\000\200\013\000\000\307\013\000\000\313\013\000\000\320\013\000\000\004\014\000\0003\014\000\000k\014\000"
  "\000s\014\000\000\256\014\000\000\267\014\000\000\334\014\000\000\345\014\000\000\357\014\000\000\360\014\000\000\362"
  "\014\000\000\021\015\000\000\023\015\000\000\036\015\000\000-\015\000\000.\015\000\0000\015\000\000S\015\000\000_\015"
  "\000\000h\015\000\000o\015\000\000p\015\000\000s\015\000\000t\015\000\000u\015\000\000v\015\000\000w\015\000\000x\015"
  "\000\000y\015\000\000{\015\000\000\205\015\000\000\224\015\000\000\230\015\000\000\231\015\000\000\232\015\000\000"
  "\234\015\000\000\371\015\000\000\037\016\000\0004\016\000\000`\016\000\000\217\016\000\000\354\016\000\000\356\016"
  "\000\0009\017\000\000:\017\000\000<\017\000\000=\017\000\000\n\n\n\n<html>\n\t<head>\n\t\t<title>VDR-Live - </title>"
  "\n\t\t\n\t\t\n\t\t<script type=\"text/javascript\" src=\"treeview.js\"></script>\n\t\t<script type=\"text/javascript"
  "\"><!--\n\t\tfunction filterRecordings(filter)\n\t\t{\n\t\t\twindow.location.href = \"recordings.html\?sort=&filter="
  "\" + encodeURIComponent(filter.value);\n\t\t}\n\t\tfunction ExpandAll()\n\t\t{\n\t\t\tvar openNodes = \"\";\n\t\t\tre"
  "cordingNodes = window.document.getElementsBySelector(\"ul.recordingslist\");\n\t\t\tfor (idx = 0; idx < recordingNode"
  "s.length; idx++) {\n\t\t\t\tif (recordingNodes[idx].parentNode.className != 'recordings') {\n\t\t\t\t\trecordingNodes"
  "[idx].style.display = 'block';\n\t\t\t\t\topenNodes += recordingNodes[idx].id + \",\"; \n\t\t\t\t}\n\t\t\t}\n\t\t\tex"
  "pandNodes = window.document.getElementsBySelector(\"img.recording_expander\");\n\t\t\tfor (idx = 0; idx < expandNodes"
  ".length; idx++) {\n\t\t\t\texpandNodes[idx].src = \"img/minus.png\";\n\t\t\t}\n\t\t\tfolderNodes = window.document.ge"
  "tElementsBySelector(\"img.recording_folder\");\n\t\t\tfor (idx = 0; idx < folderNodes.length; idx++) {\n\t\t\t\tfolde"
  "rNodes[idx].src = \"img/folder_open.png\";\n\t\t\t}\n\t\t\tcreateCookie( cookieNameRec, openNodes, 14 );\n\t\t}\n\t\t"
  "function CollapseAll()\n\t\t{\n\t\t\trecordingNodes = window.document.getElementsBySelector(\"ul.recordingslist\");\n"
  "\t\t\tfor (idx = 0; idx < recordingNodes.length; idx++) {\n\t\t\t\tif (recordingNodes[idx].parentNode.className != 'r"
  "ecordings') {\n\t\t\t\t\trecordingNodes[idx].style.display = 'none';\n\t\t\t\t}\n\t\t\t}\n\t\t\texpandNodes = window."
  "document.getElementsBySelector(\"img.recording_expander\");\n\t\t\tfor (idx = 0; idx < expandNodes.length; idx++) {\n"
  "\t\t\t\texpandNodes[idx].src = \"img/plus.png\";\n\t\t\t}\n\t\t\tfolderNodes = window.document.getElementsBySelector("
  "\"img.recording_folder\");\n\t\t\tfor (idx = 0; idx < folderNodes.length; idx++) {\n\t\t\t\tfolderNodes[idx].src = \""
  "img/folder_closed.png\";\n\t\t\t}\n\t\t\teraseCookie( cookieNameRec );\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body"
  " onload=\"adjustHeader()\" onresize=\"adjustHeader()\">\n\t\t\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<div cla"
  "ss=\"boxheader\"><div><div></div></div></div>\n\t\t\t\n\t\t\t<form method=\"post\" name=\"recordings\" action=\"recor"
  "dings.ecpp\">\n\t\t\t<div class=\"recordings\">\n\t\t\t<ul class=\"recordingslist\" style=\"display: block;\">\n\n\t"
  "\t\t</ul>\n\t\t\t</div>\n\t\t\t<div class=\"withmargin\">\n\t\t\t\t<button class=\"red\" type=\"submit\"></button>\n"
  "\t\t\t</div>\n\t\t\t</form>\n\t\t</div>\n\t</body>\n</html>\n\n\n\n\n\t<li class=\"recording\">\n\t\n\t\t<ul id=\"fld"
  "r_\" class=\"recordingslist\" style=\"display: none;\">\n\t\t</ul>\n\t</li>\n  \n  \n\n\n\n<a href=\"recordings.html"
  "\?sort=name&filter=\" /></a>\n<span class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=date&filter=\" /></a>\n<s"
  "pan class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=duplicates&filter=\" /></a>\n<span class=\"sep\">|</span>"
  "\n<a href=\"recordings.html\?sort=errors&filter=\" /></a>\n<span class=\"sep\">|</span>\n<span class=\"label bold\">:"
  "&nbsp;<input type=\"text\" name=\"filter\" value=\"\" id=\"filter\" onchange=\"filterRecordings(this)\" />&nbsp;</spa"
  "n>\n<span class=\"sep\">|</span>\n<img onclick=\"ExpandAll()\" src=\"\" alt=\"\" />\n<img onclick=\"CollapseAll()\" s"
  "rc=\"\" alt=\"\" />\n<br />\n\n\n\n<a href=\"recordings.html\?todel=\" ><img src=\"\" alt=\"\" /></a>\n\n\n<a href=\""
  "edit_recording.html\?recid=\"><img src=\"\" alt=\"\"  /></a>\n\n\n\n\n\n\n\n\n\n\n\n<img src=\"\" alt=\"on_dvd\"  />"
  "\n\n\n\n\n  <div class=\"recording_item\" onclick=\"Toggle(this)\">\n    <div class=\"recording_imgs\">\n      <img s"
  "rc=\"img/transparent.png\" width=\"px\" height=\"16px\" /> \n      <img class=\"recording_expander\" src=\"plus.png\""
  " /><img class=\"recording_folder\" src=\"folder_closed.png\" /></div>\n    <div class=\"recording_spec\">\n      <div"
  " class=\"recording_name\"></div>\n    </div>\n    <div class=\"recording_actions\">&nbsp;</div>\n  </div>\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    recordings_item(*this, "recordings_item"),
    sort_options(*this, "sort_options"),
    del_rec(*this, "del_rec"),
    edit_rec(*this, "edit_rec"),
    rec_tools(*this, "rec_tools"),
    archived_disc(*this, "archived_disc"),
    rec_item_dir(*this, "rec_item_dir"),
    delete_error(*this, "delete_error")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string sort = qparam.get< std::string >("sort");
std::string todel = qparam.get< std::string >("todel");
std::string diskinfo = qparam.get< std::string >("diskinfo");
std::string filter = qparam.get< std::string >("filter");
std::vector< std::string > deletions = qparam.getvector< std::string >("deletions");
std::string flat = qparam.get< std::string >("flat");
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n
  reply.out() << _tntChunks[2]; // \n
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 44 "recordings.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

// sort dpends on old sort, an sort parameter
currentSort = LiveSetup().GetLastSortingMode();
if (currentSort.empty() ) currentSort = "nameasc";
if (!sort.empty()) {
	if (sort == "date")
		currentSort = (currentSort == "dateasc") ? "datedesc" : "dateasc";
	else if (sort == "name")
		currentSort = (currentSort == "nameasc") ? "namedesc" : "nameasc";
	else if (sort == "errors")
                currentSort = (currentSort == "errorsasc") ? "errorsdesc" : "errorsasc";
	else if (sort == "duplicates")
		currentSort = sort;
	LiveSetup().SetLastSortingMode(currentSort);
}
// flat defaults from sort, but can we overwritten
if (currentSort == "errorsasc" || currentSort == "errorsdesc" || currentSort == "duplicates") currentFlat = "true";
  else currentFlat = "false";
if (! flat.empty() ) currentFlat = flat;

currentFilter = filter;

pageTitle = tr("Recordings");

deleteResult = "";
if (!todel.empty()) {
	if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
	deletions.push_back(todel);
}
#if TNTVERSION >= 30000
typedef std::vector<std::string> deletions_type;
#endif
for (deletions_type::const_iterator it = deletions.begin(); it != deletions.end(); ++it) {
	if (cUser::CurrentUserHasRightTo(UR_DELRECS)) {
		RemoveRecordingTask task(*it);
		LiveTaskManager().Execute(task);
		if (!task.Result())
			deleteResult += std::string() + tr("ERROR:") + " " + task.Error() + "<br/>";
		else
			deleteResult += std::string() + tr("Deleted recording:") + " " + StringReplace(task.RecName(), "~", "/") + "<br/>";
	}
	else {
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
	}
}
deletions.clear();

int FreeMB, UsedMB;
#if APIVERSNUM > 20101
int Percent = cVideoDirectory::VideoDiskSpace(&FreeMB, &UsedMB);
#else
int Percent = VideoDiskSpace(&FreeMB, &UsedMB);
#endif
int Minutes = int(double(FreeMB) / MB_PER_MINUTE);
int Hours = Minutes / 60;
Minutes %= 60;
diskinfo = cString::sprintf("%s %d%%  -  %2d:%02d %s", trVDR("Disk"), Percent, Hours, Minutes, trVDR("free"));

  // <& pageelems.doc_type ...
  { 
#line 105 "recordings.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 105 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 108 "recordings.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[4]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 109 "recordings.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 109 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 110 "recordings.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 110 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n\t\t<script type="text/javascript" src="treeview.js"></script>\n\t\t<script type="text/javascript"><!--\n\t\tfunction filterRecordings(filter)\n\t\t{\n\t\t\twindow.location.href = "recordings.html\?sort=
#line 115 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[7]; // &filter=" + encodeURIComponent(filter.value);\n\t\t}\n\t\tfunction ExpandAll()\n\t\t{\n\t\t\tvar openNodes = "";\n\t\t\trecordingNodes = window.document.getElementsBySelector("ul.recordingslist");\n\t\t\tfor (idx = 0; idx < recordingNodes.length; idx++) {\n\t\t\t\tif (recordingNodes[idx].parentNode.className != 'recordings') {\n\t\t\t\t\trecordingNodes[idx].style.display = 'block';\n\t\t\t\t\topenNodes += recordingNodes[idx].id + ","; \n\t\t\t\t}\n\t\t\t}\n\t\t\texpandNodes = window.document.getElementsBySelector("img.recording_expander");\n\t\t\tfor (idx = 0; idx < expandNodes.length; idx++) {\n\t\t\t\texpandNodes[idx].src = "img/minus.png";\n\t\t\t}\n\t\t\tfolderNodes = window.document.getElementsBySelector("img.recording_folder");\n\t\t\tfor (idx = 0; idx < folderNodes.length; idx++) {\n\t\t\t\tfolderNodes[idx].src = "img/folder_open.png";\n\t\t\t}\n\t\t\tcreateCookie( cookieNameRec, openNodes, 14 );\n\t\t}\n\t\tfunction CollapseAll()\n\t\t{\n\t\t\trecordingNodes = window.document.getElementsBySelector("ul.recordingslist");\n\t\t\tfor (idx = 0; idx < recordingNodes.length; idx++) {\n\t\t\t\tif (recordingNodes[idx].parentNode.className != 'recordings') {\n\t\t\t\t\trecordingNodes[idx].style.display = 'none';\n\t\t\t\t}\n\t\t\t}\n\t\t\texpandNodes = window.document.getElementsBySelector("img.recording_expander");\n\t\t\tfor (idx = 0; idx < expandNodes.length; idx++) {\n\t\t\t\texpandNodes[idx].src = "img/plus.png";\n\t\t\t}\n\t\t\tfolderNodes = window.document.getElementsBySelector("img.recording_folder");\n\t\t\tfor (idx = 0; idx < folderNodes.length; idx++) {\n\t\t\t\tfolderNodes[idx].src = "img/folder_closed.png";\n\t\t\t}\n\t\t\teraseCookie( cookieNameRec );\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 158 "recordings.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 158 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[8]; // \n
#line 159 "recordings.ecpp"

if (!deleteResult.empty()) {

  reply.out() << _tntChunks[9]; // \t\t
  // <& menu ...
  { 
#line 162 "recordings.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 162 "recordings.ecpp"
    _tnt_cq4.add( "active", ("recordings"));
#line 162 "recordings.ecpp"
    _tnt_cq4.add( "component", ("recordings.delete_error"));
#line 162 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[10]; // \n
#line 163 "recordings.ecpp"

} else {

  reply.out() << _tntChunks[11]; // \t\t
  // <& menu ...
  { 
#line 166 "recordings.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 166 "recordings.ecpp"
    _tnt_cq5.add( "active", ("recordings"));
#line 166 "recordings.ecpp"
    _tnt_cq5.add( "component", ("recordings.sort_options"));
#line 166 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[12]; // \n
#line 167 "recordings.ecpp"

}

  reply.out() << _tntChunks[13]; // \t\t<div class="inhalt">\n\t\t\t<div class="boxheader"><div><div>
#line 171 "recordings.ecpp"
  reply.sout() << ( std::string(tr("List of recordings")) + " (" + diskinfo + ")" );
  reply.out() << _tntChunks[14]; // </div></div></div>\n
#line 172 "recordings.ecpp"

#if VDRVERSNUM >= 20301
			int rec_cnt;
			{
				LOCK_RECORDINGS_READ;
				rec_cnt = Recordings->Count();  // Access VDRs global cRecordings Recordings instance.
			}
			if (rec_cnt == 0) {
#else
			if (Recordings.Count() == 0) { // Access VDRs global cRecordings Recordings instance.
#endif

  reply.out() << _tntChunks[15]; // \t\t\t
#line 184 "recordings.ecpp"
  reply.sout() << ( tr("No recordings found") );
  reply.out() << _tntChunks[16]; // \n
#line 185 "recordings.ecpp"

			} else {

  reply.out() << _tntChunks[17]; // \t\t\t<form method="post" name="recordings" action="recordings.ecpp">\n\t\t\t<div class="recordings">\n\t\t\t<ul class="recordingslist" style="display: block;">\n
  // <& recordings.recordings_item ...
  { 
#line 191 "recordings.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 191 "recordings.ecpp"
    _tnt_cq6.add( "filter", (currentFilter));
#line 191 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[18]; // \n\t\t\t</ul>\n\t\t\t</div>\n\t\t\t<div class="withmargin">\n\t\t\t\t<button class="red" type="submit">
#line 195 "recordings.ecpp"
  reply.sout() << ( tr("Delete selected") );
  reply.out() << _tntChunks[19]; // </button>\n\t\t\t</div>\n\t\t\t</form>\n
#line 198 "recordings.ecpp"

			}

  reply.out() << _tntChunks[20]; // \t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[21]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[22]; // \n
  reply.out() << _tntChunks[23]; // \n\n
  reply.out() << _tntChunks[32]; // \n
  reply.out() << _tntChunks[33]; // \n\n
  reply.out() << _tntChunks[53]; // \n
  reply.out() << _tntChunks[54]; // \n\n
  reply.out() << _tntChunks[59]; // \n
  reply.out() << _tntChunks[60]; // \n\n
  reply.out() << _tntChunks[65]; // \n
  reply.out() << _tntChunks[66]; // \n\n\n
  reply.out() << _tntChunks[72]; // \n
  reply.out() << _tntChunks[73]; // \n\n
  reply.out() << _tntChunks[78]; // \n
  reply.out() << _tntChunks[79]; // \n\n
  reply.out() << _tntChunks[88]; // \n
  reply.out() << _tntChunks[89]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::recordings_item_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::recordings_item " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string filter = qparam.get< std::string >("filter");
std::vector< std::string > path = qparam.getvector< std::string >("path");
int counter = qparam.get< int >("counter", ( 0));
std::string idHash = qparam.get< std::string >("idHash", ( ""));
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 215 "recordings.ecpp"

recoring_item.reserve(6000);
// Max Buffer used: 5.636 bytes
RecordingsTreePtr recordingsTree(LiveRecordingsManager()->GetRecordingsTree());
std::list<RecordingsItemPtr> recItems;
std::list<RecordingsItemPtr>::iterator recIter;
if( currentFlat != "true" ) {
RecordingsMap::iterator iter;
RecordingsMap::iterator end = recordingsTree->end(path);

for (iter = recordingsTree->begin(path); iter != end; ++iter) {
	RecordingsItemPtr recItem = iter->second;
	if (recItem->IsDir()) {
		recItems.push_back(recItem);
	}
}
if (currentSort == "namedesc")
	recItems.sort(RecordingsItemPtrCompare::ByDescendingNameDescSort);
else if (currentSort == "nameasc")
	recItems.sort(RecordingsItemPtrCompare::ByAscendingNameDescSort);
for (recIter = recItems.begin(); recIter != recItems.end(); ++recIter) {
	RecordingsItemPtr recItem = *recIter;
	counter++;

	/* search trough directory for new recordings */
        bool newR = false;
	if ( LiveSetup().GetMarkNewRec() ) {
           std::vector<std::string> p(path); 
	   p.push_back(recItem->Name()); 
	   newR = checkNew(recordingsTree, p);; 
        }

  reply.out() << _tntChunks[24]; // \t<li class="recording">\n\t
  // <& rec_item_dir ...
  { 
#line 248 "recordings.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 248 "recordings.ecpp"
    _tnt_cq7.add( "level", (recItem->Level() ));
#line 248 "recordings.ecpp"
    _tnt_cq7.add( "name", (recItem->Name()));
#line 248 "recordings.ecpp"
    _tnt_cq7.add( "newR", (newR ? "_new" : ""));
#line 248 "recordings.ecpp"
  main().rec_item_dir(request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[25]; // \n
#line 249 "recordings.ecpp"

#if TNT_QUERYPARAMS_NO_BOOL
		tnt::QueryParams recItemParams(qparam);
#else
		tnt::QueryParams recItemParams(qparam, false);
#endif
#if TNTVERSION >= 30000
		recItemParams.add("path[]", recItem->Name());
#else
		recItemParams.add("path", recItem->Name());
#endif
		std::string combinedId = recItem->Name() + "_";
		combinedId += counter + "_" + recItem->Level();
		idHash = MD5Hash(combinedId);

  reply.out() << _tntChunks[26]; // \t\t<ul id="fldr_
#line 264 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[27]; // " class="recordingslist" style="display: none;">\n
#line 265 "recordings.ecpp"

		callComp("recordings.recordings_item", request, reply, recItemParams);

  reply.out() << _tntChunks[28]; // \t\t</ul>\n\t</li>\n
#line 270 "recordings.ecpp"

}
recItems.clear();
for (iter = recordingsTree->begin(path); iter != end; ++iter) {
	RecordingsItemPtr recItem = iter->second;
	if (!recItem->IsDir()) {
		recItems.push_back(recItem);
	}
}
} else {
if (currentSort == "duplicates") {
  addAllDuplicateRecordings(recItems, recordingsTree);
} else {
  addAllRecordings(recItems, recordingsTree, path);
}
}
if (currentSort == "dateasc")
	recItems.sort(RecordingsItemPtrCompare::ByAscendingDate);
else if (currentSort == "datedesc")
	recItems.sort(RecordingsItemPtrCompare::ByDescendingDate);
else if (currentSort == "namedesc")
	recItems.sort(RecordingsItemPtrCompare::ByDescendingNameDescSort);
else if (currentSort == "nameasc")
	recItems.sort(RecordingsItemPtrCompare::ByAscendingNameDescSort);
else if (currentSort == "errorsasc" || currentSort == "errorsdesc")
	recItems.sort(RecordingsItemPtrCompare::ByDescendingRecordingErrors);

argList.clear();
argList.append("&sort=");
argList.append(currentSort);
argList.append("&filter=");
argList.append(currentFilter);
for (recIter = recItems.begin(); recIter != recItems.end(); ++recIter) {
		RecordingsItemPtr recItem = *recIter;
  recoring_item.clear();
  recItem->AppendasHtml(recoring_item, currentFlat == "true", argList, path);
  max_length_recoring_item = std::max(max_length_recoring_item, recoring_item.length() );
#ifdef HAVE_PCRE2
  StringMatch sm(filter);
  if (filter.empty() or
      sm.Matches(recItem->Name()) or
      sm.Matches(recItem->ShortText()?recItem->ShortText() : "" ) or
      sm.Matches(recItem->Description()?recItem->Description() : ""))
#endif
		{

  reply.out() << _tntChunks[29]; //   
#line 316 "recordings.ecpp"
  reply.out() << ( recoring_item );
  reply.out() << _tntChunks[30]; // \n  
  reply.out() << _tntChunks[31]; // \n
#line 319 "recordings.ecpp"

		}
}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::sort_options_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::sort_options " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 328 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[34]; // <a href="recordings.html\?sort=name&filter=
#line 329 "recordings.ecpp"
  if ( currentFilter != "" )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[35]; // " />
#line 329 "recordings.ecpp"
  reply.sout() << ( tr("Sort by name") );
  reply.out() << _tntChunks[36]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=date&filter=
#line 331 "recordings.ecpp"
  if ( currentFilter != "" )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[37]; // " />
#line 331 "recordings.ecpp"
  reply.sout() << ( tr("Sort by date") );
  reply.out() << _tntChunks[38]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=duplicates&filter=
#line 333 "recordings.ecpp"
  if ( currentFilter != "" )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[39]; // " />
#line 333 "recordings.ecpp"
  reply.sout() << ( tr("Duplicates") );
  reply.out() << _tntChunks[40]; // </a>\n
#line 334 "recordings.ecpp"

#if VDRVERSNUM >= 20505

  reply.out() << _tntChunks[41]; // <span class="sep">|</span>\n<a href="recordings.html\?sort=errors&filter=
#line 338 "recordings.ecpp"
  if ( currentFilter != "" )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[42]; // " />
#line 338 "recordings.ecpp"
  reply.sout() << ( tr("Errors") );
  reply.out() << _tntChunks[43]; // </a>\n
#line 339 "recordings.ecpp"

#endif
#ifdef HAVE_PCRE2

  reply.out() << _tntChunks[44]; // <span class="sep">|</span>\n<span class="label bold">
#line 344 "recordings.ecpp"
  reply.sout() << ( tr("Filter") );
  reply.out() << _tntChunks[45]; // :&nbsp;<input type="text" name="filter" value="
#line 344 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[46]; // " id="filter" onchange="filterRecordings(this)" />&nbsp;
  // <& tooltip.help ...
  { 
#line 344 "recordings.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 344 "recordings.ecpp"
    _tnt_cq8.add( "text", (tr("Look in recordings titles and subtitles for the given string and display only the matching ones. You may also use perl compatible regular expressions (PCRE).")));
#line 344 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[47]; // </span>\n
#line 345 "recordings.ecpp"

#endif

  reply.out() << _tntChunks[48]; // <span class="sep">|</span>\n<img onclick="ExpandAll()" src="
#line 349 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "plus.png") );
  reply.out() << _tntChunks[49]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 349 "recordings.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 349 "recordings.ecpp"
    _tnt_cq9.add( "text", (tr("Expand all folders")));
#line 349 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[50]; // />\n<img onclick="CollapseAll()" src="
#line 350 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "minus.png") );
  reply.out() << _tntChunks[51]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 350 "recordings.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 350 "recordings.ecpp"
    _tnt_cq10.add( "text", (tr("Collapse all folders")));
#line 350 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[52]; // />\n<br />\n
#line 352 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::del_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::del_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 361 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[55]; // <a href="recordings.html\?todel=
#line 361 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[56]; // " 
  // <& tooltip.hint ...
  { 
#line 361 "recordings.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 361 "recordings.ecpp"
    _tnt_cq11.add( "text", (tr("Delete this recording from hard disc!")));
#line 361 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[57]; // ><img src="
#line 361 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[58]; // " alt="" /></a>
#line 361 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::edit_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 370 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[61]; // <a href="edit_recording.html\?recid=
#line 370 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[62]; // "><img src="
#line 370 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << _tntChunks[63]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 370 "recordings.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 370 "recordings.ecpp"
    _tnt_cq12.add( "text", (tr("Edit recording")));
#line 370 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[64]; //  /></a>
#line 370 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::rec_tools_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_tools " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string title = qparam.get< std::string >("title");
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& pageelems.ajax_action_href ...
  { 
#line 381 "recordings.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 381 "recordings.ecpp"
    _tnt_cq13.add( "action", "play_recording");
#line 381 "recordings.ecpp"
    _tnt_cq13.add( "alt", "");
#line 381 "recordings.ecpp"
    _tnt_cq13.add( "image", "play.png");
#line 381 "recordings.ecpp"
    _tnt_cq13.add( "param", (id));
#line 381 "recordings.ecpp"
    _tnt_cq13.add( "tip", (tr("play this recording.")));
#line 381 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[67]; // \n
  // <& pageelems.m3u_playlist_recording ...
  { 
#line 382 "recordings.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 382 "recordings.ecpp"
    _tnt_cq14.add( "recid", (id));
#line 382 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_recording"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[68]; // \n
  // <& pageelems.imdb_info_href ...
  { 
#line 383 "recordings.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 383 "recordings.ecpp"
    _tnt_cq15.add( "title", (title));
#line 383 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[69]; // \n
  // <& recordings.edit_rec ...
  { 
#line 384 "recordings.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 384 "recordings.ecpp"
    _tnt_cq16.add( "id", (id));
#line 384 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "edit_rec"), request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[70]; // \n
  // <& recordings.del_rec ...
  { 
#line 385 "recordings.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 385 "recordings.ecpp"
    _tnt_cq17.add( "id", (id));
#line 385 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "del_rec"), request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[71]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::archived_disc_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::archived_disc " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string archived = qparam.get< std::string >("archived");
std::string title = qparam.get< std::string >("title");
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[74]; // <img src="
#line 395 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << _tntChunks[75]; // " alt="on_dvd" 
  // <& tooltip.hint ...
  { 
#line 395 "recordings.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 395 "recordings.ecpp"
    _tnt_cq18.add( "text", (archived));
#line 395 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[76]; //  />\n
  // <& pageelems.imdb_info_href ...
  { 
#line 396 "recordings.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 396 "recordings.ecpp"
    _tnt_cq19.add( "title", (title));
#line 396 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[77]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::rec_item_dir_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_item_dir " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string name = qparam.get< std::string >("name");
int level = qparam.get< int >("level");
std::string newR = qparam.get< std::string >("newR");
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[80]; //   <div class="recording_item" onclick="Toggle(this)">\n    <div class="recording_imgs">\n      
#line 409 "recordings.ecpp"
 if(level > 1) { 
  reply.out() << _tntChunks[81]; // <img src="img/transparent.png" width="
#line 409 "recordings.ecpp"
  reply.sout() << (16*(level-1) );
  reply.out() << _tntChunks[82]; // px" height="16px" /> 
#line 409 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[83]; // \n      <img class="recording_expander" src="
#line 410 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[84]; // plus.png" /><img class="recording_folder" src="
#line 410 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[85]; // folder_closed.png" /></div>\n    <div class="recording_spec">\n      <div class="recording_name
#line 412 "recordings.ecpp"
  reply.sout() << ( newR );
  reply.out() << _tntChunks[86]; // ">
#line 412 "recordings.ecpp"
  reply.sout() << ( name );
  reply.out() << _tntChunks[87]; // </div>\n    </div>\n    <div class="recording_actions">&nbsp;</div>\n  </div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::delete_error_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::delete_error " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& recordings.sort_options ...
  { 
#line 421 "recordings.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 421 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "sort_options"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[90]; // \n
#line 422 "recordings.ecpp"
 { reply.out() << deleteResult; } 
  // <%/cpp>
  return DEFAULT;
}

} // namespace
